	PRG_COUNT	= 1
	CHR_COUNT	= 1
	MAPPER		= 0
	MIRRORING	= %0001
	
	.db "NES",$1A
	.db PRG_COUNT
	.db CHR_COUNT
	.db MAPPER|MIRRORING
	.dsb 9,$00
	
	.enum $0000
	pointer1		.dsb 2
	sleeping		.dsb 1
	nmi_enabled		.dsb 1
	buttons			.dsb 1
	buttons_old		.dsb 1
	buttons_pressed	.dsb 1
	tempvar			.dsb 1
	player_x		.dsb 1
	player_hb_x		.dsb 1
	player_y		.dsb 1
	player_hb_y		.dsb 1
	;coordinates for looking up data in the collision map
	player_x1y1		.dsb 1
	player_x2y1		.dsb 1
	player_x1y2		.dsb 1
	player_x2y2		.dsb 1
	.ende
	
	.base $C000
RESET:
	sei
	cld
	ldx #$40
	stx $4017
	ldx #$FF
	txs
	inx
	stx $2000
	stx $2001
	stx $4010
VBlankWait1:
	bit $2002
	bpl VBlankWait1
ClrMem:
	lda #$00
	sta $00,x
	sta $0100,x
	sta $0300,x
	sta $0400,x
	sta $0500,x
	sta $0600,x
	sta $0700,x
	lda #$FE
	sta $0200,x
	inx
	bne ClrMem
VBlankWait2:
	bit $2002
	bpl VBlankWait2
	
LoadPalette:
	lda $2002
	lda #$3F
	sta $2006
	lda #$00
	sta $2006
	ldx #$00
-	lda Palette,x
	sta $2007
	inx
	cpx #32
	bne -
	
LoadNametable:
	lda $2002
	lda #$20
	sta $2006
	lda #$00
	sta $2006
	lda #<TestNametable
	sta pointer1
	lda #>TestNametable
	sta pointer1+1
	ldy #$00
	ldx #$04
-	lda (pointer1),y
	sta $2007
	iny
	bne -
	inc pointer1+1
	dex
	bne -
	
LoadAttributes:
	lda $2002
	lda #$23
	sta $2006
	lda #$C0
	sta $2006
	ldx #$00
-	lda TestAttributes,x
	sta $2007
	inx
	cpx #64
	bne -
	
LoadPlayerSprite:
	ldx #$00
-	lda PlayerSprites,x
	sta $0200,x
	inx
	cpx #24
	bne -
	
	lda #$80
	sta player_x
	lda #$C0
	sta player_y
	jsr UpdatePlayerHitbox
	
	lda #%10010000
	sta $2000
	
MainLoop:
	inc sleeping
@waitFrame:
	lda sleeping
	bne @waitFrame
	
	jsr ReadControllers
	
	;find where player is on the background collision grid
	;upper-left corner
	lda player_y
	and #%11110000
	sta tempvar
	lda player_x
	lsr
	lsr
	lsr
	lsr
	clc
	adc tempvar
	sta player_x1y1
	;upper-right corner
	lda player_hb_x
	lsr
	lsr
	lsr
	lsr
	clc
	adc tempvar
	sta player_x2y1
	;lower-left corner
	lda player_hb_y
	and #%11110000
	sta tempvar
	lda player_x
	lsr
	lsr
	lsr
	lsr
	clc
	adc tempvar
	sta player_x1y2
	;lower-right corner
	lda player_hb_x
	lsr
	lsr
	lsr
	lsr
	clc
	adc tempvar
	sta player_x2y2
	
ReadUp:
	lda buttons
	and #%00001000
	beq ReadDown
	dec player_y
	ldx player_x1y1
	lda TestCollisionData,x
	bne +
	ldx player_x2y1
	lda TestCollisionData,x
	bne +
	beq ++	;should always branch
+	inc player_y
++	jmp InputRead
ReadDown:
	lda buttons
	and #%00000100
	beq ReadLeft
	inc player_y
	ldx player_x1y2
	lda TestCollisionData,x
	bne +
	ldx player_x2y2
	lda TestCollisionData,x
	bne +
	beq ++
+	dec player_y
++	jmp InputRead
ReadLeft:
	lda buttons
	and #%00000010
	beq ReadRight
	dec player_x
	ldx player_x1y1
	lda TestCollisionData,x
	bne +
	ldx player_x1y2
	lda TestCollisionData,x
	bne +
	beq ++
+	inc player_x
++	jmp InputRead
ReadRight:
	lda buttons
	and #%00000001
	beq InputRead
	inc player_x
	ldx player_x2y1
	lda TestCollisionData,x
	bne +
	ldx player_x2y2
	lda TestCollisionData,x
	bne +
	beq InputRead
+	dec player_x
InputRead:
	jsr UpdatePlayerHitbox
	jsr UpdatePlayerMetaSprite
	
	jmp MainLoop
	
NMI:
	pha
	txa
	pha
	tya
	pha
	
	lda #$00
	sta $2003
	lda #$02
	sta $4014
	
	lda #$00
	sta $2006
	sta $2006
	sta $2005
	sta $2005
	
	lda #%00011110
	sta $2001
	
	dec sleeping
	
	pla
	tay
	pla
	tax
	pla
	rti
	
ReadControllers:
	lda buttons
	sta buttons_old
	ldx #$01
	stx $4016
	dex
	stx $4016
	ldx #$08
-	lda $4016
	lsr
	rol buttons
	dex
	bne -
	lda buttons_old
	eor #$FF
	and buttons
	sta buttons_pressed
	rts
	
UpdatePlayerHitbox:
	lda player_x
	clc
	adc #15
	sta player_hb_x
	lda player_y
	clc
	adc #23
	sta player_hb_y
	rts
	
UpdatePlayerMetaSprite:
	lda player_y
	sta $0200
	sta $0204
	clc
	adc #8
	sta $0208
	sta $020C
	adc #8
	sta $0210
	sta $0214
	lda player_x
	sta $0203
	sta $020B
	sta $0213
	clc
	adc #8
	sta $0207
	sta $020F
	sta $0217
	rts
	
	.org $E000
Palette:
	.db $0F,$00,$10,$30,$0F,$00,$10,$30,$0F,$00,$10,$30,$0F,$00,$10,$30
	.db $0F,$0F,$0F,$30,$0F,$0F,$30,$0F,$0F,$0F,$30,$0F,$0F,$0F,$30,$0F
	
PlayerSprites:
	.db $C0,$00,$00,$80
	.db $C0,$00,$00,$88
	.db $C8,$00,$00,$80
	.db $C8,$00,$00,$88
	.db $D0,$00,$00,$80
	.db $D0,$00,$00,$88
	
TestNametable:
	;the actual game engine uses metatiles, but I decided to not use them in this demo
	.incbin "bg_collision_demo/testnametable.bin"
	
TestAttributes:
	.incbin "bg_collision_demo/testattributes.bin"
	
TestCollisionData:
	.db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
	.db $01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db $01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db $01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db $01,$00,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01,$00,$00,$00,$01
	.db $01,$00,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01,$00,$00,$00,$01
	.db $01,$00,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01,$00,$00,$00,$01
	.db $01,$00,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01,$00,$00,$00,$01
	.db $01,$00,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01,$00,$00,$00,$01
	.db $01,$00,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01,$00,$00,$00,$01
	.db $01,$00,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01,$00,$00,$00,$01
	.db $01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db $01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db $01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
	
	.org $FFFA
	.dw NMI
	.dw RESET
	.dw 0
	
	.incbin "bg_collision_demo/test.chr"